clear
clc
clear all

rng('default');

N=80;
Zeta=0.01;
ump=0;
maxx=40;

for i=1:maxx
    Links=MinimumDistance(N,2*N);
    [NeighbourM,NeighbourICon]=MakingNeighbourMatrix(Links,N);
    Lambdamu=rand(1,N)*400-100;
    if sum(Lambdamu)<0
        Lambdamu=rand(1,N)*300-100;
    end
    a=max(NeighbourICon);
    if a>7
        a=7;
    end
    for j=2:a
        Lambdasig=zeros(1,N);
        b=find(NeighbourICon==j);
        if length(b)>4
            for k=1:4
                c=randi(length(b));
                while Lambdasig(b(c))~=0
                    c=randi(length(b));
                end
                Lambdasig(b(c))=50;
            end
            [Satisfied, Edges]=QuenchedWithZeta(Lambdamu,Lambdasig,Links,Zeta);
            ump=ump+1;
            Cost(ump)=sum(Edges(:,3).^2);
            DD(ump)=j;
        end
    end
    
end

j=zeros(1,8);
CC=zeros(max(DD),maxx*a);
for i=1:ump
    a=DD(i);
    j(a)=j(a)+1;
    CC(a,j(a))=Cost(i);
end

M=zeros(1,max(DD));
S=M;
for i=min(DD):max(DD)
    CCC=CC(i,:);
    CCC(find(CCC==0))=[];
    M(i)=mean(CCC);
    S(i)=std(CCC);
end


figure('Units','centimeters','Position',[5 5 16 13],'PaperPositionMode','auto')
M(1)=NaN;

p=errorbar(M,S,'*');

xlabel('Average Degree of Uncertain Nodes');
ylabel('Transportation Cost');
axis([1 8 20000 65000]);
set(p,'MarkerEdgeColor',[0 0 0],'Marker','*','MarkerSize',8,'LineStyle','-','LineWidth',2,'Color',[0.6 0 1]);
set(gca,'YLim',[20000 65000],'YColor',[0 0 0],'XLim',[1 8]);
set(gca,...
'Units','normalized',...
'YTick',20000:10000:65000,...
'XTick',2:7,...
'Position',[.17 .15 .7 .7],...
'FontUnits','points',...
'FontWeight','normal',...
'FontSize',18,...
'FontName','Times',...
'TickDir','out')
ylabel('Transportation Cost',...
'FontUnits','points',...
'interpreter','latex',...
'FontSize',20,...
'Color','k',...
'FontName','Times',...
'Position',[0.5 40000 0])
xlabel('Degree of Volatile Nodes',...
'FontUnits','points',...
'interpreter','latex',...
'FontWeight','normal',...
'FontSize',20,...
'FontName','Times',...
'Position',[4 14000 0])
print -dpng CostVsDD.png


